// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _HILDONMM_BUTTON_H
#define _HILDONMM_BUTTON_H


#include <glibmm.h>

/*
 * Copyright (c) 2009  The maemomm Development Team
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtkmm/button.h>
#include <gtkmm/enums.h>
#include <gtkmm/sizegroup.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _HildonButton HildonButton;
typedef struct _HildonButtonClass HildonButtonClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Hildon
{ class Button_Class; } // namespace Hildon
namespace Hildon
{

/** @addtogroup hildonmmEnums Enums and Flags */

/**
 * @ingroup hildonmmEnums
 */
enum ButtonArrangement
{
  BUTTON_ARRANGEMENT_HORIZONTAL,
  BUTTON_ARRANGEMENT_VERTICAL
};

} // namespace Hildon


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Hildon::ButtonArrangement> : public Glib::Value_Enum<Hildon::ButtonArrangement>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Hildon
{

/**
 * @ingroup hildonmmEnums
 */
enum ButtonStyle
{
  BUTTON_STYLE_NORMAL,
  BUTTON_STYLE_PICKER
};

} // namespace Hildon


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Hildon::ButtonStyle> : public Glib::Value_Enum<Hildon::ButtonStyle>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Hildon
{


class Button : public Gtk::Button
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Button CppObjectType;
  typedef Button_Class CppClassType;
  typedef HildonButton BaseObjectType;
  typedef HildonButtonClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Button();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class Button_Class;
  static CppClassType button_class_;

  // noncopyable
  Button(const Button&);
  Button& operator=(const Button&);

protected:
  explicit Button(const Glib::ConstructParams& construct_params);
  explicit Button(HildonButton* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  HildonButton*       gobj()       { return reinterpret_cast<HildonButton*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const HildonButton* gobj() const { return reinterpret_cast<HildonButton*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:


public:
  Button();
  explicit Button(Gtk::Hildon::SizeType size, ButtonArrangement arrangement);
  explicit Button(Gtk::Hildon::SizeType size, ButtonArrangement arrangement,
                    const Glib::ustring& title, const Glib::ustring& value);

  
  void set_title(const Glib::ustring& title);
  void unset_title();
  
  Glib::ustring get_title() const;

  
  void set_value(const Glib::ustring& value);
  void unset_value();
  
  Glib::ustring get_value() const;

  
  void set_text(const Glib::ustring& title, const Glib::ustring& value);

  
  void set_image(Gtk::Widget& image);
  void unset_image();
  
  Gtk::Widget* get_image();
  
  const Gtk::Widget* get_image() const;

  
  void set_image_position(Gtk::PositionType position);

  
  void set_alignment(float xalign, float yalign, float xscale, float yscale);

  
  void set_title_alignment(float xalign, float yalign);
  
  void set_value_alignment(float xalign, float yalign);
  
  void set_image_alignment(float xalign, float yalign);

  
  void add_title_size_group(const Glib::RefPtr<Gtk::SizeGroup>& size_group);
  
  void add_value_size_group(const Glib::RefPtr<Gtk::SizeGroup>& size_group);
  
  void add_image_size_group(const Glib::RefPtr<Gtk::SizeGroup>& size_group);

  
  void add_size_groups(const Glib::RefPtr<Gtk::SizeGroup>& title_size_group,
                                    const Glib::RefPtr<Gtk::SizeGroup>& value_size_group,
                                    const Glib::RefPtr<Gtk::SizeGroup>& image_size_group);

  
  void set_button_style(ButtonStyle style);
  
  ButtonStyle get_button_style() const;


};

} // namespace Hildon


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Hildon::Button
   */
  Hildon::Button* wrap(HildonButton* object, bool take_copy = false);
} //namespace Glib


#endif /* _HILDONMM_BUTTON_H */

